/******************************************************************
 * @file  receiver_symb_func.h
 * @brief:    [file description] 
 * @author: HUOHUO
 * @Date 2024年4月20日
 * COPYRIGHT NOTICE: ITTC
 * Change_date         Owner         Change_content
 * 2024年4月20日        HUOHUO       create file
*****************************************************************/
#ifndef RECEIVER_SYMB_FUNC_H
#define RECEIVER_SYMB_FUNC_H
/****************************include*****************************/
#include "common.h"
#include "mem_def.h"
#include "phy_macro.h"
#include "receiver_symb_macro.h"
#include "receiver_symb_struct.h"
#include "ape_common.h"
#include "drv_ape.h"
#include "log_interface.h"
#include "msg_interface.h"
#include "osp_ape.h"
#include "task_define.h"
#include "trace.h"
#include "freOffEstImpl.h"
#include "freOffCompImpl.h"
#include "Transform.h"
#include "interface_rec_symb2_rec_bit.h"
//include mpu header files




//微码配置空间偏移结构体
extern receiver_symb_table_param_t  g_receiver_symb_table_param;
extern uint32_t *receiver_symb_config_dm0_ptr;
extern uint32_t *receiver_symb_config_dm1_ptr;
extern uint32_t *receiver_symb_config_dm2_ptr;
extern uint32_t *receiver_symb_config_dm3_ptr;
extern int32_t storedfreoffestvalue ;

void Receiver_Symb_Init();
void Receiver_Symb_Task(receiver_sync2symb_t* msg_ptr, uint32_t msg_len);
void Receiver_Symb_Proc(
    receiver_sync2symb_t* param_ptr,
    int32_t* temp_dm0_ptr,
    int32_t* temp_dm1_ptr,
    int32_t* temp_dm2_ptr,
    int32_t* temp_dm3_ptr
);


void FreOff_Proc(
    uint32_t *param_ptr,
    int32_t  *temp_dm0_ptr,
    int32_t  *temp_dm1_ptr,
    int32_t* temp_dm2_ptr,
    int32_t* temp_dm3_ptr
);


void ChannelEst_Proc(
    uint32_t *param_ptr,
    int32_t  *temp_dm0_ptr,
    int32_t  *temp_dm1_ptr,
    int32_t  *temp_dm2_ptr,
	int32_t  *temp_dm3_ptr

);

void ChannelEqu_Proc(
	uint32_t* param_data_ptr,
    int32_t  *temp_dm0_ptr,
    int32_t  *temp_dm1_ptr,
	int32_t* temp_dm2_ptr,
	int32_t* temp_dm3_ptr

);

void Transform_Proc(
    uint32_t *param_ptr,
    int32_t  *temp_dm0_ptr,
    int32_t  *temp_dm1_ptr,
	int32_t  *temp_dm2_ptr,
	int32_t  *temp_dm3_ptr
);

#endif
