/******************************************************************
 * @file  receiver_symb_struct.h
 * @brief:    [file description] 
 * @author: HUOHUO
 * @Date 2024年10月30日
 * COPYRIGHT NOTICE: ITTC
 * Change_date         Owner         Change_content
 * 2024年10月30日        HUOHUO       create file

*****************************************************************/
#ifndef RECEIVER_SYMB_STRUCT_H
#define RECEIVER_SYMB_STRUCT_H
#include "type_define.h"
#include "interface_rec_sync2_rec_symb.h"

//GENERATE with Generate_receiver_symb_struct_h.m
//DO NOT MODIFY
//=======================================================================
//各微码或查找表偏移及指针定义
typedef struct receiver_symb_table_param_s
{
    //MPU CONFIG OFFSET 基地址
    uint32_t    FreOffEst_CFG1_Offset;
    uint32_t    FreOffComp_CFG2_Offset;
    uint32_t    FreOffCordic_CFG3_Offset;
    uint32_t    ChannelEst_CFG4_Offset;
    uint32_t    Fft4096Int32_CFG5_Offset;
    uint32_t    EQ21Part1_CFG6_Offset;
    uint32_t    IFFT4096_CFG7_Offset;
    uint32_t    DeTransform2_CFG8_Offset;
    uint32_t    DeTransform4_CFG9_Offset;
    // 存储微码参数表的ddr基地址和长度
    uint32_t    receiver_symb_config0_ddr_ptr;//receiver DM0微码配置文件ddr地址
    uint32_t    receiver_symb_config0_length;//receiver DM0微码配置文件ddr长度    
    uint32_t    receiver_symb_config1_ddr_ptr;//receiver DM1微码配置文件ddr地址
    uint32_t    receiver_symb_config1_length;//receiver DM1微码配置文件ddr长度
    uint32_t    receiver_symb_config2_ddr_ptr;//receiver DM2微码配置文件ddr地址
    uint32_t    receiver_symb_config2_length;//receiver DM2微码配置文件ddr地址
    uint32_t    receiver_symb_config3_ddr_ptr;//receiver DM3微码配置文件ddr地址
    uint32_t    receiver_symb_config3_length;//receiver DM3微码配置文件ddr地址

    //SPU查找表在SM中的偏移地址



    // SPU LUT SM基地址和长度
    uint32_t    pucch_lut_sm_ptr; //PUCCH查找表在SM中的基地址
    uint32_t    pucch_lut_length; //PUCCH查找表总长度

}receiver_symb_table_param_t;


//=======================================================================
#endif