
#include "receiver_symb_func.h"
#include "ByteSet.h"


void ChannelEqu_Proc(
	uint32_t* param_data_ptr,
    int32_t  *temp_dm0_ptr,
    int32_t  *temp_dm1_ptr,
	int32_t* temp_dm2_ptr,
	int32_t* temp_dm3_ptr

)
{
    //局部变量定义
    int32_t  *cfg_addr = receiver_symb_config_dm0_ptr + RECEIVER_SYMB_FREOFF_CFG_LENGTH + RECEIVER_SYMB_CHANNELEST_CFG_LENGTH;
    int32_t  *lut_addr = receiver_symb_config_dm2_ptr + RECEIVER_SYMB_PilotOrig_LUT1_LENGTH;
	uint32_t *ConfigByteSet = receiver_symb_config_dm0_ptr + RECEIVER_SYMB_COMMEN_CFG_LENGTH;

 
    uint32_t res_ptr = CHANNELEQU_DATA_DDR_PTR;             //Store result of Equ


	// Temporary input for test
	uint32_t * InputNoise = ((((uint32_t)&temp_dm3_ptr[0] + 4095)>>12)<<12);

	ByteSet(ConfigByteSet,0,MPU_ADDR(InputNoise),16384);
	SVRReg[0] = MPU_ADDR(ConfigByteSet);
	ByteSetAsm(SVRReg);
	WAIT_MPU_STOP;


	// available address space for channelEqu
	uint32_t * available_ptr_dm0 = temp_dm0_ptr;
	uint32_t * available_ptr_dm1 = temp_dm1_ptr;
	uint32_t * available_ptr_dm2 = temp_dm2_ptr;
	uint32_t * available_ptr_dm3 = InputNoise + 0x1000;


	// Configuration
    uint32_t *CfgFft4096Int32 = cfg_addr;
    uint32_t *CfgEQ21Part1 = cfg_addr + RECEIVER_SYMB_Fft4096Int32_CFG5_LENGTH;
    uint32_t *CfgEQ1Part2 = cfg_addr + RECEIVER_SYMB_Fft4096Int32_CFG5_LENGTH + RECEIVER_SYMB_EQ21Part1_CFG6_LENGTH;
    uint32_t *CfgIFFT4096 =  cfg_addr + RECEIVER_SYMB_Fft4096Int32_CFG5_LENGTH + RECEIVER_SYMB_EQ21Part1_CFG6_LENGTH + RECEIVER_SYMB_EQ1Part2_CFG6_1_LENGTH;
    uint32_t *CfgIFFT4096TURN =  cfg_addr + RECEIVER_SYMB_Fft4096Int32_CFG5_LENGTH + RECEIVER_SYMB_EQ21Part1_CFG6_LENGTH + RECEIVER_SYMB_EQ1Part2_CFG6_1_LENGTH + RECEIVER_SYMB_IFFT4096_CFG7_LENGTH;
	uint32_t *CfgAgcShift = CfgIFFT4096TURN + RECEIVER_SYMB_IFFT4096_TURN_CFG7_LENGTH;
    uint32_t *CfgIFFT4096AddCP = CfgIFFT4096TURN + RECEIVER_SYMB_IFFT4096_TURN_CFG7_LENGTH + RECEIVER_SYMB_AgcShiftFft_CFG7_LENGTH;

	uint32_t *CfgByteCopy= receiver_symb_config_dm0_ptr + RECEIVER_SYMB_COMMEN_CFG_LENGTH + RECEIVER_SYMB_ByteSet_CFG10_LENGTH;
    // LUT
    uint32_t *Lut_W4096 = lut_addr;
    uint32_t *Lut_EqFactor0 = lut_addr + RECEIVER_SYMB_EqW4096_LUT2_LENGTH;
    uint32_t *Lut_EqFactor1 = receiver_symb_config_dm3_ptr;
    uint32_t *Lut_EqFactor = receiver_symb_config_dm1_ptr;
    uint32_t *Lut_Zero = lut_addr + RECEIVER_SYMB_EqW4096_LUT2_LENGTH + RECEIVER_SYMB_EqFactor0_LUT3_LENGTH + RECEIVER_SYMB_EqFactor1_LUT4_LENGTH;   //useless
    uint32_t *Lut_phase =  lut_addr + RECEIVER_SYMB_EqW4096_LUT2_LENGTH + RECEIVER_SYMB_EqFactor0_LUT3_LENGTH + RECEIVER_SYMB_EqFactor1_LUT4_LENGTH + RECEIVER_SYMB_EqFactor_LUT5_LENGTH ;
    uint32_t *Lut_agcFactor = lut_addr + RECEIVER_SYMB_EqW4096_LUT2_LENGTH + RECEIVER_SYMB_EqFactor0_LUT3_LENGTH + RECEIVER_SYMB_EqFactor1_LUT4_LENGTH + RECEIVER_SYMB_EqFactor_LUT5_LENGTH + RECEIVER_SYMB_EqCpPhase_LUT6_LENGTH;


    // channelEst and data
    uint32_t *InputCHEst_ddr_ptr = (uint32_t *)CHANNELEST_DATA_DDR_PTR;
    uint32_t *InputData_ddr_ptr = (uint32_t *)(COMPENSATED_DATA_DDR_PTR + 2048*4); //去除导频
    ChannelEquImpl(CfgFft4096Int32,CfgEQ21Part1,CfgEQ1Part2,CfgIFFT4096,CfgIFFT4096TURN,CfgIFFT4096AddCP,CfgByteCopy,CfgAgcShift,
    			available_ptr_dm0,
    			available_ptr_dm1,
				available_ptr_dm2 ,
				available_ptr_dm3 ,
				InputCHEst_ddr_ptr,
				InputData_ddr_ptr,
				Lut_Zero,
    			InputNoise,
				Lut_W4096,
				Lut_EqFactor0,
				Lut_EqFactor1,
				Lut_EqFactor,
				Lut_phase,
				Lut_agcFactor,
				res_ptr
    );


}

