/******************************************************************
 * @file  Receiver_Symb_Init.s.c
 * @brief:    [file description] 
 * @author: HUOHUO
 * @Date 2024年10月30日
 * COPYRIGHT NOTICE: ITTC
 * Change_date         Owner         Change_content
 * 2024年10月30日        HUOHUO       create file

*****************************************************************/
#include "receiver_symb_func.h"

extern uint32_t g_symb2bit_buffer_sel;
 /*!   
 * @brief:  Receiver任务启动前的初始化工作
 *          初始化全局参数，ddr查找表搬入SM
 * @author:  HUOHUO
 * @Date:  2024年10月30日
 */
void Receiver_Symb_Init()
{
    int32_t  ret;
    uint32_t lutDdrAddr,idx;

    //DM0
    
    //DM1

    //DM2

    //DM3

    //SM

    g_symb2bit_buffer_sel = 0;

    //9. 微码配置文件ddr地址初始化
    ret = osp_get_cfgfile("Receiver_Symb_cfg_dm0.dat",
                          (uint32_t *)&(g_receiver_symb_table_param.receiver_symb_config0_ddr_ptr),
                          (int32_t *)&(g_receiver_symb_table_param.receiver_symb_config0_length));
    if(0 != ret)
    {
        //LOG_ERROR_S("Receiver_Symb_cfg_dm0.dat not found!\n");
    } 
    ret = osp_get_cfgfile("Receiver_Symb_cfg_dm1.dat",
                          (uint32_t *)&(g_receiver_symb_table_param.receiver_symb_config1_ddr_ptr),
                          (int32_t *)&(g_receiver_symb_table_param.receiver_symb_config1_length));
    if(0 != ret)
    {
        //LOG_ERROR_S("Receiver_Symb_cfg_dm1.dat not found!\n");
    } 
    ret = osp_get_cfgfile("Receiver_Symb_cfg_dm2.dat",
                          (uint32_t *)&(g_receiver_symb_table_param.receiver_symb_config2_ddr_ptr),
                          (int32_t *)&(g_receiver_symb_table_param.receiver_symb_config2_length));
    if(0 != ret)
    {
        //LOG_ERROR_S("Receiver_Symb_cfg_dm2.dat not found!\n");
    }                           
    ret = osp_get_cfgfile("Receiver_Symb_cfg_dm3.dat",
                          (uint32_t *)&(g_receiver_symb_table_param.receiver_symb_config3_ddr_ptr),
                          (int32_t *)&(g_receiver_symb_table_param.receiver_symb_config3_length));
    if(0 != ret)
    {
        //LOG_ERROR_S("Receiver_Symb_cfg_dm3.dat not found!\n");
    }  

#ifdef RECV_SYMB_DBG_DATA_TEST
    uint32_t timedata_ptr;
    int32_t timedata_len;
    ret = osp_get_cfgfile("timedatasym.dat",
                              (uint32_t *)&(timedata_ptr),
                           (int32_t *)&(timedata_len));
             
     if(-1 == ret)
     {
         LOG_ERROR_S("timedatasym.dat not found!\n");
     } 
 
    //  int* param_ptr = (int *)RECEIVER_SYMB_CFG_BASE;
    //  STORE_EX_W(param_ptr, timedata_ptr);
    //  STORE_EX_W((param_ptr+1), timedata_len);
    ape_csu_dma_1D_G2L_ch2ch3_transfer((uint64_t)(timedata_ptr),
    (uint64_t)JESD_NRFDD_RX_SLOT_EVEN_DATA_ADDR,//第一次固定搬移到dm0
    timedata_len,
    DMA_TAG_G2G,
    1);
    ape_csu_dma_1D_G2L_ch2ch3_transfer((uint64_t)(timedata_ptr),
    (uint64_t)JESD_NRFDD_RX_SLOT_ODD_DATA_ADDR,//第一次固定搬移到dm0
    timedata_len,
    DMA_TAG_G2G,
    1);  

#endif
    uint32_t ptr1,ptr2,len1,len2;
    ret = osp_get_cfgfile("channel_est_1_Quan.dat",
                              (uint32_t *)&(ptr1),
                           (int32_t *)&(len1));
             
     if(-1 == ret)
     {
         LOG_ERROR_S("timedatasym.dat not found!\n");
     } 
     ape_csu_dma_1D_G2L_ch2ch3_transfer((uint64_t)(ptr1),
     (uint64_t)CHANNELEST_DATA_DDR_PTR,//第一次固定搬移到dm0
     len1,
     DMA_TAG_G2G,
     1); 
     ret = osp_get_cfgfile("EquIn_Quan.dat",
        (uint32_t *)&(ptr2),
     (int32_t *)&(len2));

    if(-1 == ret)
    {
    LOG_ERROR_S("timedatasym.dat not found!\n");
    } 
    ape_csu_dma_1D_G2L_ch2ch3_transfer((uint64_t)(ptr2),
    (uint64_t)COMPENSATED_DATA_DDR_PTR,//第一次固定搬移到dm0
    len2,
    DMA_TAG_G2G,
    1); 


}
