#include <stdlib.h>
#include <math.h>
#include <Transform.h>
#define PI 3.1415926
#define imag(x) (((x)&0xffff)<<16)
#define real(x) ((x)&0xffff)

//factor range in  [0~1]

void GenParam(double db_real[], double db_imag[], int* i_real,int* i_imag, int degree,int direct){

	switch(degree){
	case(2):
	{
		double p_real[2] = {0};
		double p_imag[2] = {0};
		double G1_I[2] = { db_real[0], db_real[0] };
		double G1_Q[2] = { db_imag[0], db_imag[0] };
		double G2_I[2] = { db_real[1],-db_real[1] };
		double G2_Q[2] = { db_imag[1], -db_imag[1] };
double I[2];
		double Q[2];
		I[0] = (G1_I[0] + G2_I[0]) / 2;
		Q[0] = (G1_Q[0] + G2_Q[0]) / 2;
		I[1] = (G1_I[1] + G2_I[1]) / 2;
		Q[1] = (G1_Q[1] + G2_Q[1]) / 2;
		for(int j = 0;j<2;j++){
			p_real[j] = I[j];
			p_imag[j] = Q[j];
		}
		//now convert double to int

		for(int j=0; j<2; j++)
		{
			//i_real[j] = (int)(p_real[j]*16384);
			//i_imag[j] = (int)(p_imag[j]*16384);
			i_real[j] = (int)(p_real[j]*4096);
			i_imag[j] = (int)(p_imag[j]*4096);
		}

		break;
	}
	case(4):
	{
		double p_real[4] = {0};
		double p_imag[4] = {0};
		double G1_I[4] = { db_real[0], db_real[0] ,db_real[0], db_real[0]};//[1 1 1 1]
		double G1_Q[4] = { db_imag[0], db_imag[0] ,db_imag[0], db_imag[0]};

		double G2_I[4] = { db_real[1],-db_imag[1] ,-db_real[1] ,db_imag[1] };//[1 i -1 -i]
		double G2_Q[4] = { db_imag[1],db_real[1] ,-db_imag[1] ,-db_real[1] };

		double G3_I[4] = { db_real[2], -db_real[2],db_real[2], -db_real[2] };//[1 -1 1 -1]
		double G3_Q[4] = { db_imag[2], -db_imag[2],db_imag[2], -db_imag[2] };

		double G4_I[4] = { db_real[3], db_imag[3], -db_real[3] , -db_imag[3] };//[1 -i -1 i]
		double G4_Q[4] = { db_imag[3], -db_real[3], -db_imag[3], db_real[3] };
		double I[4];
		double Q[4];
		for(int i =0;i<4;i++){
			I[i] = (G1_I[i] + G2_I[i] + G3_I[i] + G4_I[i]) / 4;
			Q[i] = (G1_Q[i] + G2_Q[i] + G3_Q[i] + G4_Q[i]) / 4;
		}

		if(direct == 1){
			p_imag[0] = Q[0];
			p_real[0] = I[0];
			p_imag[1] = Q[3];
			p_real[1] = I[3];
			p_imag[2] = Q[2];
			p_real[2] = I[2];
			p_imag[3] = Q[1];
			p_real[3] = I[1];
		}
		else{
			for(int j = 0;j<4;j++){
				//p_real[j] = (G1_I[j] + G2_I[j] + G3_I[j] + G4_I[j]) / 4;
				//p_imag[j] = (G1_Q[j] + G2_Q[j] + G3_Q[j] + G4_Q[j]) / 4;//conj
				p_real[j] = I[j];
				p_imag[j] = Q[j];
			}

		}
//now convert double to int

		for(int j=0; j<4; j++)
		{
			//i_real[j] = (int)(p_real[j]*16384);
			//i_imag[j] = (int)(p_imag[j]*16384);
			i_real[j] = (int)(p_real[j]*4096);
			i_imag[j] = (int)(p_imag[j]*4096);
		}
		break;
	}
	case(8):
	{
		double p_real[8] = {0};
		double p_imag[8] = {0};
		double G1_I[4] = { db_real[0], db_real[0] ,db_real[0], db_real[0]};//[1 1 1 1]
		double G1_Q[4] = { db_imag[0], db_imag[0] ,db_imag[0], db_imag[0]};

		double G2_I[4] = { db_real[1],-db_imag[1] ,-db_real[1] ,db_imag[1] };//[1 i -1 -i]
		double G2_Q[4] = { db_imag[1],db_real[1] ,-db_imag[1] ,-db_real[1] };

		double G3_I[4] = { db_real[2], -db_real[2],db_real[2], -db_real[2] };//[1 -1 1 -1]
		double G3_Q[4] = { db_imag[2], -db_imag[2],db_imag[2], -db_imag[2] };

		double G4_I[4] = { db_real[3], db_imag[3], -db_real[3] , -db_imag[3] };//[1 -i -1 i]
		double G4_Q[4] = { db_imag[3], -db_real[3], -db_imag[3], db_real[3] };
		double I[8];
		double Q[8];
		for(int j=0; j<4; j++)
		{
		    I[2*j] = (G1_I[j] + G2_I[j]) / 4;
		    Q[2*j] = (G1_Q[j] + G2_Q[j]) / 4;
		    I[2*j+1] = (G3_I[j] + G4_I[j]) / 4;
		    Q[2*j+1] = (G3_Q[j] + G4_Q[j]) / 4;
		}

		if(direct == 1){
			p_imag[0] = Q[0];
			p_real[0] = I[0];

			p_imag[1] = Q[7];
			p_real[1] = I[7];

			p_imag[2] = Q[6];
			p_real[2] = I[6];

			p_imag[3] = Q[5];
			p_real[3] = I[5];

			p_imag[4] = Q[4];
			p_real[4] = I[4];

			p_imag[5] = Q[3];
			p_real[5] = I[3];

			p_imag[6] = Q[2];
			p_real[6] = I[2];

			p_imag[7] = Q[1];
			p_real[7] = I[1];
		}
		else{
			for(int j = 0;j<8;j++){
				p_real[j] = I[j];
				p_imag[j] = Q[j];
			}

}
		//now convert double to int

		for(int j=0; j<8; j++)
		{
			//i_real[j] = (int)(p_real[j]*16384);
			//i_imag[j] = (int)(p_imag[j]*16384);
			i_real[j] = (int)(p_real[j]*4096);
			i_imag[j] = (int)(p_imag[j]*4096);
		}
		break;
	}
	}
}

void get_thita(int* current_state, double* thita)
{
	int tmp = (current_state[0] + current_state[4]) % 2;
	for (int i = 1; i < 9; i++)
	{
		current_state[i - 1] = current_state[i];
	}
	current_state[8] = tmp;
	int* p = current_state + 9;
	tmp = (p[0] + p[2]) % 2;
	for (int i = 1; i < 11; i++)
	{
		p[i - 1] = p[i];
	}
	p[10] = tmp;
	p += 11;
	tmp = (p[0] + p[1]+p[3]+p[4]) % 2;
	for (int i = 1; i < 13; i++)
	{
		p[i - 1] = p[i];
	}
	p[12] = tmp;
	thita[0] = 0;
	for (int i = 0; i < 3; i++)
	{
		thita[0] += current_state[i] << i;
	}
	thita[0] = thita[0] / 8 * 2 * PI;
	thita[1] = 0;
	for (int i = 0; i < 3; i++)
	{
		thita[1] += current_state[i+4] << i;
	}
	thita[1] = thita[1] / 8 * 2 * PI;
	thita[2] = 0;
	for (int i = 0; i < 3; i++)
	{
		thita[2] += current_state[i + 7] << i;
	}
	thita[2] = thita[2] / 8 * 2 * PI;
	thita[3] = 0;
	for (int i = 0; i < 3; i++)
	{
		thita[3] += current_state[i + 10] << i;
	}
	thita[3] = thita[3] / 8 * 2 * PI;
	thita[4] = 0;
	for (int i = 0; i < 3; i++)
	{
		thita[4] += current_state[i + 13] << i;
	}
	thita[4] = thita[4] / 8 * 2 * PI;
	thita[5] = 0;
	for (int i = 0; i < 3; i++)
	{
		thita[4] += current_state[i + 16] << i;
	}
	thita[4] = thita[4] / 8 * 2 * PI;
}

int sign_extend_16_to_32(int num)
{
	return (num<<16)>>16;
}

void Transform(int ConfigAddr, int InAddr, int OutAddr, int N, double* db_real, double* db_imag, int direct)
{
	volatile int a;
	int *Para = (int *)ConfigAddr;

	int i_real[8] = {0};
	int i_imag[8] = {0};

	GenParam(db_real, db_imag, i_real, i_imag,N,direct);

	switch(N)
	{
	case(2):
		{
		for(int i=0;i<2;i++){
			for(int j=0;j<16;j++){
				Para[16*(i+4) + j] = (real(i_real[i])) + (imag(i_imag[i]));
			}
		}
				for(int i=0;i<2;i++){
//Para[i] = 1792;//3584/2
			Para[i] = 224;//14*512/(2*16)
		}
				Para[16*2 + 0] = InAddr;		//KB0
		Para[16*2 + 1] = InAddr;		//KB1
		Para[16*2 + 2] = InAddr;		//KB2
		Para[16*2 + 3] = InAddr;		//KB3
		//Para[16*2 + 4] = 114688;		//KS0
		Para[16*2 + 4] = 14336;		//KS0	14*512*32/8
		//Para[16*2 + 5] = 16384;			//KS1
		Para[16*2 + 5] = 2048;			//KS1	512*32/8
		Para[16*2 + 6] = 64;			//KS2
		Para[16*2 + 7] = 0;			//KS3
		Para[16*2 + 8] = (2<<16) + 2;		//KC0 KI0
		Para[16*2 + 9] = (7<<16) + 7;	//KC1 KI1
		//Para[16*2 + 10] = (256<<16) + 256;	//KC2 KI2
		Para[16*2 + 10] = (32<<16) + 32;	//KC2 KI2	512/16

		Para[16*3 + 0] = OutAddr;		//KB0
		Para[16*3 + 1] = OutAddr;		//KB1
		Para[16*3 + 2] = OutAddr;		//KB2
		Para[16*3 + 4] = 14336;			//KS0
		Para[16*3 + 5] = 2048;			//KS1
		Para[16*3 + 6] = 64;		//KS2
		Para[16*3 + 8] = (2<<16) + 2;	//KC0 KI0
		Para[16*3 + 9] = (7<<16) + 7;		//KC1 KI1
		Para[16*3 + 10] = (32<<16) + 32;	//KC2 KI2
		break;
	}
	case(4):
	{
		for(int i=0;i<4;i++){
			for(int j=0;j<16;j++){
				Para[16*(i+4) + j] = (real(i_real[i])) + (imag(i_imag[i]));
			}
		}
				for(int i=0;i<4;i++){
//Para[i] = 896;//3584/4
			Para[i] = 128;//4096*2/(4*16)
		}
		Para[16*2 + 0] = InAddr;		//KB0
		Para[16*2 + 1] = InAddr;		//KB1
		Para[16*2 + 2] = InAddr;		//KB2
		Para[16*2 + 3] = InAddr;		//KB3
		Para[16*2 + 4] = 4096;		//KS0
		Para[16*2 + 5] = 64;			//KS1
		Para[16*2 + 6] = 16384;			//KS2
		Para[16*2 + 7] = 0;			//KS3
		Para[16*2 + 8] = (4<<16) + 4;		//KC0 KI0
		Para[16*2 + 9] = (64<<16) + 64;	//KC1 KI1
		//Para[16*2 + 10] = (14<<16) + 14;	//KC2 KI2
		Para[16*2 + 10] = (2<<16) + 2;	//KC2 KI2	change to 2 one time handle 2 row

		Para[16*3 + 0] = OutAddr;		//KB0
		Para[16*3 + 1] = OutAddr;		//KB1
		Para[16*3 + 2] = OutAddr;		//KB2
		Para[16*3 + 4] = 4096;			//KS0
		Para[16*3 + 5] = 64;			//KS1
		Para[16*3 + 6] = 16384;		//KS2
		Para[16*3 + 8] = (4<<16) + 4;	//KC0 KI0
		Para[16*3 + 9] = (64<<16) + 64;		//KC1 KI1
		//Para[16*3 + 10] = (14<<16) + 14;	//KC2 KI2
		Para[16*3 + 10] = (2<<16) + 2;	//KC2 KI2
		break;
	}
	case(8):
	{
		for(int i=0;i<N;i++){
			for(int j=0;j<16;j++){
				Para[16*(i+4) + j] = (real(i_real[i])) + (imag(i_imag[i]));
			}
		}
				for(int i=0;i<N;i++){
			Para[i] = 8;//64/8
		}

		Para[16*2 + 0] = InAddr;		//KB0
		Para[16*2 + 1] = InAddr;		//KB1
		Para[16*2 + 2] = InAddr;		//KB2
		Para[16*2 + 3] = InAddr;		//KB3
		Para[16*2 + 4] = 512;		//KS0
		Para[16*2 + 5] = 64;			//KS1
		Para[16*2 + 6] = 0;			//KS2
		//Para[16*2 + 7] = 0;			//KS3
		Para[16*2 + 8] = (8<<16) + 8;		//KC0 KI0
		Para[16*2 + 9] = (8<<16) + 8;	//KC1 KI1
		Para[16*2 + 10] = (8<<16) + 8;	//KC2 KI2

		Para[16*3 + 0] = OutAddr;		//KB0
		Para[16*3 + 1] = OutAddr;		//KB1
		Para[16*3 + 2] = OutAddr;		//KB2
		Para[16*3 + 4] = 512;			//KS0
		Para[16*3 + 5] = 64;			//KS1
		Para[16*3 + 6] = 2048;		//KS2
		Para[16*3 + 8] = (4<<16) + 4;	//KC0 KI0
		Para[16*3 + 9] = (8<<16) + 8;		//KC1 KI1
		Para[16*3 + 10] = (2<<16) + 2;	//KC2 KI2

/*
		Para[16*3 + 0] = OutAddr;		//KB0
		Para[16*3 + 1] = OutAddr;		//KB1
		Para[16*3 + 2] = OutAddr;		//KB2
		Para[16*3 + 4] = 64;			//KS0
		Para[16*3 + 5] = 512;			//KS1
		//Para[16*3 + 6] = 0;		//KS2
		Para[16*3 + 8] = (8<<16) + 8;	//KC0 KI0
		Para[16*3 + 9] = (8<<16) + 8;		//KC1 KI1
		//Para[16*3 + 10] = 0;	//KC2 KI2
		*/
		break;
	}
	}
}


void RowCopy(int* Matrix,int* Block,int idx,int direct)
{
	int RowOffset = 4096*2;
	//idx from 0 to 6
	int BaseAddr = RowOffset*idx;
	if(direct == 1)
	{
		//load data from Matrix
		for(int i = BaseAddr;i<BaseAddr+RowOffset;i++)
		{
			Block[i-BaseAddr] = Matrix[i];
		}
	}
	else
	{
		//store data to Matrix
		for(int i = BaseAddr;i<BaseAddr+RowOffset;i++)
		{
			Matrix[i] = Block[i-BaseAddr];
		}
	}
}

void ColCopy(int* Matrix,int* Block,int idx,int direct)
{
	int ColOffset = 512;
	int RowOffset = 4096;
	int BaseAddr = idx*ColOffset;

	if(direct == 1)
	{
		for(int i = 0;i<14;i++){
		for(int j = 0;j<ColOffset;j++)
		{
			Block[j+i*ColOffset] = Matrix[BaseAddr+i*RowOffset+j];
		}
		}
	}
	else
	{
		for(int i = 0;i<14;i++){
				for(int j = 0;j<ColOffset;j++)
				{
					Matrix[BaseAddr+i*RowOffset+j] = Block[j+i*ColOffset];
				}
		}
	}
}
