void Fft4096Int32(
	int Config,
	int numSym,
	int Scale,
	int *ShiftFactor,
	int in_WnAddr,
	int io_Addr0,
	int io_Addr1,
	int io_Addr2,
	int io_Addr3,
	int out_ScaleAddr0,
	int out_ScaleAddr1
)
{
	volatile int *Para = (volatile int *)Config;

	//m[00]:KIs
	Para[0 * 16 + 0] = numSym;
	Para[0 * 16 + 1] = 256;
	Para[0 * 16 + 2] = numSym * 256;
	Para[0 * 16 + 3] = 2;

	//m[01]:load(ASI)
	//m[02]:load(signal)(br)
	Para[2 * 16 + 0] = io_Addr0;			//for ant0
	Para[2 * 16 + 1] = io_Addr0;
	Para[2 * 16 + 10]= (numSym << 16) | numSym;
	Para[2 * 16 + 11]= io_Addr0 + 0x4000;	//BaseAddr += 4096Words

	Para[2 * 16 + 14]= io_Addr1;			//for ant1
	Para[2 * 16 + 15]= io_Addr1 + 0x4000;

	//m[03]:store(fft_1_4)
	Para[3 * 16 + 0] = io_Addr2;			//for ant0
	Para[3 * 16 + 1] = io_Addr2;
	Para[3 * 16 + 2] = io_Addr2;
	Para[3 * 16 + 3] = io_Addr2;

	Para[3 * 16 + 11]= io_Addr3;			//for ant1

	//m[04]:factors
	Para[4 * 16 + 0] = (0x3f - ShiftFactor[0]) & 0x3f;
	Para[4 * 16 + 1] = (- ShiftFactor[1]) & 0x3f;
	Para[4 * 16 + 2] = (- ShiftFactor[2]) & 0x3f;
	Para[4 * 16 + 3] = (- ShiftFactor[3]) & 0x3f;
	Para[4 * 16 + 4] = (- ShiftFactor[4]) & 0x3f;
	Para[4 * 16 + 5] = (- ShiftFactor[5]) & 0x3f;
	Para[4 * 16 + 6] = (- ShiftFactor[6]) & 0x3f;
	Para[4 * 16 + 7] = (- ShiftFactor[7]) & 0x3f;
	Para[4 * 16 + 8] = (- ShiftFactor[8]) & 0x3f;
	Para[4 * 16 + 9] = (- ShiftFactor[9]) & 0x3f;
	Para[4 * 16 +10] = (- ShiftFactor[10]) & 0x3f;
	Para[4 * 16 +11] = (- ShiftFactor[11]) & 0x3f;

	//m[05]:load(Wn_1-4)
	Para[5 * 16 + 0] = in_WnAddr;
	//m[06]:shu(Wn) for fft_2
	//m[07]:shu(Wn) for fft_3
	//m[08]:shu(Wn) for fft_4
	/*m[09]:shu(signal) for fft_1A*/
	/*m[10]:shu(signal) for fft_1B*/
	/*m[11]:shu(signal) for fft_1A*/
	/*m[12]:shu(signal) for fft_1B*/
	/*m[13]:shu(signal) for fft_2A*/
	/*m[14]:shu(signal) for fft_2B*/
	/*m[15]:shu(signal) for fft_3A*/
	/*m[16]:shu(signal) for fft_3A*/

	/*m[17]:load fft_4 in col, 16 dwords/cow	*/
	Para[17 * 16 + 0] = io_Addr2;					//for ant0
	Para[17 * 16 + 1] = io_Addr2;
	Para[17 * 16 + 9] = (numSym << 16) | numSym;
	Para[17 * 16 + 10]= 0x00020002;					//for 2 ants

	Para[17 * 16 + 11]= io_Addr3;					//for ant1

	/*m[18]:store fft_8 in col, 16 dwords/cow	*/
	Para[18 * 16 + 0] = io_Addr0;					//for ant0
	Para[18 * 16 + 1] = io_Addr0;
	Para[18 * 16 + 2] = io_Addr0;
	Para[18 * 16 + 10] = (numSym << 16) | numSym;

	Para[18 * 16 + 11]= io_Addr1;					//for ant1

	/*m[19]:load Wn_5							*/
	/*m[20]:load Wn_6							*/
	/*m[21]:load Wn_7							*/
	/*m[22]:load Wn_8							*/
	Para[19 * 16 + 0] = in_WnAddr + 15 * 8;
	Para[20 * 16 + 0] = in_WnAddr + 31 * 8;
	Para[21 * 16 + 0] = in_WnAddr + 63 * 8;
	Para[22 * 16 + 0] = in_WnAddr + 127 * 8;

	/*m[23]:shu(Wn) for fft_5					*/
	/*m[24]:shu(Wn) for fft_6					*/
	/*m[25]:shu(Wn) for fft_7					*/
	/*m[26]:shu(Wn) for fft_8					*/
	/*m[27]:shu for fft_5A_9A					*/
	/*m[28]:shu for fft_5B_9B					*/
	/*m[29]:shu for fft_6A_10A					*/
	/*m[30]:shu for fft_6B_10B					*/
	/*m[31]:shu for fft_7A_11A					*/
	/*m[32]:shu for fft_7B_11B					*/
	/*m[33]:shu for fft_8A_12A					*/
	/*m[34]:shu for fft_8B_12B					*/


	/*m[35]:load fft_8 in row, 16 dwords/row	*/
	Para[35 * 16 + 0] = io_Addr0;				//for ant0
	Para[35 * 16 + 1] = io_Addr0;
	Para[35 * 16 + 2] = io_Addr0;
	Para[35 * 16 + 3] = io_Addr0;

	Para[35 * 16 + 11]= io_Addr1;				//for ant1

	/*m[36]:store fft_12 in row, 16 dwords/row	*/
	Para[36 * 16 + 0] = io_Addr2;				//for ant0
	Para[36 * 16 + 1] = io_Addr2;
	Para[36 * 16 + 2] = io_Addr2;
	Para[36 * 16 +10] = (numSym << 16) | numSym;

	Para[36 * 16 + 11]= io_Addr3;				//for ant1

	/*m[37]:load Wn_9_12_t						*/
	Para[37 * 16 + 0] = in_WnAddr + 255 * 8;
	Para[37 * 16 + 1] = in_WnAddr + 255 * 8;
	Para[37 * 16 + 2] = in_WnAddr + 255 * 8;

	//m[38]:load fft_int32_0 in row
	Para[38 * 16 + 0] = io_Addr2;				//for ant0
	Para[38 * 16 + 1] = io_Addr2;
	Para[38 * 16 + 9] = (numSym << 16) | numSym;

	//m[39]:store 16 MinFirst1_0 in row
	Para[39 * 16 + 0] = io_Addr0;				//for ant0
	Para[39 * 16 + 8] = (numSym << 16) | numSym;

	//m[40]:load fft_int32_1 in row
	Para[40 * 16 + 0] = io_Addr3;				//for ant1
	Para[40 * 16 + 1] = io_Addr3;
	Para[40 * 16 + 9] = (numSym << 16) | numSym;

	//m[41]:store 16 MinFirst1_1 in row
	Para[41 * 16 + 0] = io_Addr1;				//for ant1
	Para[41 * 16 + 8] = (numSym << 16) | numSym;

	//m[42]:load 16 MinFirst1_0 in col
	Para[42 * 16 + 0] = io_Addr0;				//for ant0

	//m[43]:load 16 MinFirst1_1 in col
	Para[43 * 16 + 0] = io_Addr1;				//for ant1

	//m[44]:scale = 13 for now
	Para[44 * 16 + 0] = 31 - Scale;
	Para[44 * 16 + 1] = ShiftFactor[0] + 6;		//标值输出偏置
	/****************************************************************************************\
	FFT_scale = Scale-ceil(log2(double(max(max(abs(real(data_out))),max(abs(imag(data_out)))))))+6+ShiftFactor[0];
	FFT_scale = 13-ceil(log2(double(max(max(abs(real(data_out))),max(abs(imag(data_out))))))) + 6 + ShiftFactor[0]
		= 13 - (31 - min(first1)) + 6 + ShiftFactor[0]
		= 6 + ShiftFactor[0] - (18 - min(first1));
	\****************************************************************************************/

	//m[45]:shu for get fft_int16,scale extraction
	//m[46]:store fft_int16_0
	Para[46 * 16 + 0] = io_Addr0;				//for ant0
	Para[46 * 16 + 1] = io_Addr0;
	Para[46 * 16 + 9] = (numSym << 16) | numSym;

	//m[47]:store fft_int16_1
	Para[47 * 16 + 0] = io_Addr1;				//for ant1
	Para[47 * 16 + 1] = io_Addr1;
	Para[47 * 16 + 9] = (numSym << 16) | numSym;

	//m[48]:copy fft_int16_0 from io_Addr0
	Para[48 * 16 + 0] = io_Addr0;				//for ant0
	Para[48 * 16 + 1] = io_Addr0;
	Para[48 * 16 + 9] = (numSym << 16) | numSym;

	//m[49]:copy fft_int16_1 from io_Addr1
	Para[49 * 16 + 0] = io_Addr1;				//for ant1
	Para[49 * 16 + 1] = io_Addr1;
	Para[49 * 16 + 9] = (numSym << 16) | numSym;

	//m[50]:copy fft_int16_0 to io_Addr2
	Para[50 * 16 + 0] = io_Addr2;				//for ant0
	Para[50 * 16 + 1] = io_Addr2;
	Para[50 * 16 + 9] = (numSym << 16) | numSym;

	//m[51]:copy fft_int16_1 to io_Addr3
	Para[51 * 16 + 0] = io_Addr3;				//for ant1
	Para[51 * 16 + 1] = io_Addr3;
	Para[51 * 16 + 9] = (numSym << 16) | numSym;

	//m[52]:scale output
	Para[52 * 16 + 0] = out_ScaleAddr0;			//for ant0
	Para[52 * 16 + 1] = out_ScaleAddr1;			//for ant1
}
